# A Word on Contributing

Contributing to a project is not only adding slabs of code, fixing bugs, or creating optimizations, but it is also contributing to programmers, CTOs, fathers, mothers, sons and daughters. This project isn't about a team of developers or a "we the programmers" yacht club. It really about "us" and helpings others climb that same mountain. Whether the top of the mountain is making more money, improving your developing skills, or spending more time with your family we're all climbing the same rocks.

> CleverStack aims to not be a framework or a stack, but an ecosystem. [An ecosystem is a community of living organisms (plants, animals and microbes) in conjunction with the nonliving components of their environment (things like air, water and mineral soil), interacting as a system](http://en.wikipedia.org/wiki/Ecosystem).

> The vision for CleverStack is not to be the best performance framework (although, there is certainly concern for that), including support for all of the gadgets and gizmos (this too, is welcomed), or to be the next buzzword (it would be cool to see others talking about it though) it's more about shifting a developer into a different mindset. A mindset in which not only takes the [modularization principles](http://en.wikipedia.org/wiki/Modular_programming) on a vertical scale (e.g. reducing developing time), but a horizontal scale too (e.g. not needing to focus on every single detail, but being able to take a step back and look at your environment across the horizon).

> I just wanted to thank you for not only looking into contributing towards CleverStack, but for even taking your time to considering it. I'm personally always available to lend out a hand, and I hope you never feel as if you can't reach out to me. I always look forward to discussing ideas, solving problems, and colloborating with others.

> - Daniel Durante

## Submitting bug reports, issues, or enhancement requests.

There are currently a few resources available to reach out to us:

1. [GitHub Issues](https://github.com/CleverStack/cleverstack-cli/issues)
2. [Stack Overflow](http://stackoverflow.com/questions/tagged/cleverstack)
3. [Google Groups/Mailing list](https://groups.google.com/forum/#!forum/cleverstack)
4. [IRC](http://webchat.freenode.net/?randomnick=1&channels=%23cleverstack&uio=d4)
5. [CleverTech's Contact Form](http://www.clevertech.biz/contact.html)

## Submitting Pull Requests

1. Fork the repo
2. Create a new branch following the [Gitflow](https://www.atlassian.com/git/workflows#!workflow-gitflow) structure.
3. Refactors and documentation changes do not require a test, but if you're adding a new function please write a tests for that feature.
4. Please follow the [coding guidelines](https://github.com/CleverStack/cleverstack-cli/blob/master/.jshintrc)
5. Push your changes and submit a [pull request](https://github.com/CleverStack/cleverstack-cli/compare/) to the master branch.
